﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

/// <summary>
/// Наблюдатель 
/// Паттерн "Наблюдатель" (Observer) представляет поведенческий шаблон проектирования, который использует отношение "один ко многим". 
/// В этом отношении есть один наблюдаемый объект и множество наблюдателей. И при изменении наблюдаемого объекта автоматически происходит оповещение всех наблюдателей.
/// </summary>
namespace Observe
{
    class Program
    {
        static void Main(string[] args)
        {
            FigureNotifier n = new FigureNotifier();

            n.AddObserver(new TriangleObserver());
            n.AddObserver(new SquareObserver());

            n.NotifyObservers();

            Console.ReadKey();
        }
    }
}
